// =====================================
// Функции-методы для класса WinApp
// =====================================

#define STRICT
#include <windows.h>
#include <mem.h>
#include "winapp.hpp"

// -------------------------------------
// Конструктор класса Window
// -------------------------------------

#pragma argsused
WinApp::WinApp(HINSTANCE hInst, HINSTANCE hPrevInstance,
	       LPSTR     lpszCmdLine, int nCmdShow)
{
  // Сбрасываем флаг ошибки
  errno = 0;

  // Сохраняем идентификатор приложения
  hInstance = hInst;
}

// -------------------------------------
// Регистрация класса окна
// -------------------------------------

BOOL
WinApp::RegisterWndClass(LPSTR szClassName, WNDPROC WndProc)
{
  ATOM aWndClass; // атом для кода возврата
  WNDCLASS wc;    // структура для регистрации
                  // класса окна

  memset(&wc, 0, sizeof(wc));

  wc.style         = 0;
  wc.lpfnWndProc   = (WNDPROC) WndProc;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;
  wc.hInstance     = hInstance;
  wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName  = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  aWndClass = RegisterClass(&wc);
  return (aWndClass != 0);
}

// -------------------------------------
// Запуск цикла обработки сообщений
// -------------------------------------

WORD
WinApp::Go(void)
{
  // Запускаем цикл обработки сообщений
  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }
  return msg.wParam;
}
